/** Nes.c       ****/
/*                 */
/*******************/
#include        <stdio.h>
#include        <pc.h>
#include        <allegro.h>
#include        "m6502\m6502.h"
#include        "xnes.h"
#include        "nes.h"

#include        "pal.h"

int     Toggle = 0;

//
// Refresh_Screen
//
int Refresh_Screen( void )
{
        byte    index, color, bit_2, bit_3;				//****
        int     TileCounter;                                                    //****

        int     x,y,i;
        int     addr , ColorTable;               //****
        int     Square_Reel , Square = 0;
        int     Bit_0,Bit_1,pos,CurrentTile;
        int     Tile = 1;
        int     Ligne = 1;
        int     Base,Base_X,Base_Y;
        int     Bloc;
        int     Current_Addr;
        int     CurrentBloc;
        int     Next_NameTable;
        int     Dest_Name;
        int     X_START,Y_START;
        int     Old_x,Current_Checksum = 0;
        int     temp,Table;
        int     Origin;

        x = 0;
        y = 0;

        switch( RAM[ 0x2000 ] & 0x03 )
        {
                case    0:
                        NameTable = 0x2000;
                        break;
                case    1:
                        NameTable = 0x2400;
                        Origin = 0x2800;
                        break;
                case    2:
                        NameTable = 0x2800;
                        Origin = 0x2C00;
                        break;
                case    3:
                        NameTable = 0x2C00;
                        Origin = 0x2000;
                        break;
        }

        Origin = NameTable;

        ColorTable = NameTable+0x3C0;					//****

        CurrentTile = 1;

        Square = 0;

        Bloc = 1;

        Base = NameTable;

        x = 0;
        y = 0;

        TileCounter = 0;

        for( i = NameTable ; i < NameTable+0x03C0 ; i++ )
        {
                addr = VRAM[ i ]<<4;                                              //****

				if (TileCounter & 0x40)					//****
					index = 4;							//****
				else							  		//****
					index = 0;							//****

				pos = (TileCounter & 0x380) >> 4;		//****
				pos += (TileCounter & 0x1F) >> 2;		//****
				index += (TileCounter & 0x02);			//****
                                color = VRAM[ ColorTable + pos];                 //****
				bit_2 = ReadBit(color, index);			//****
				bit_3 = ReadBit(color, index + 1);		//****
				TileCounter += 1;

                addr += ReadBit( RAM[ 0x2000 ] , 4 )*0x1000;
//                if( ReadBit( RAM[ 0x2000 ] , 4 ) == 1 )
//                        addr += 0x1000; 

                                if( x+8 >= PPU_REG_5B-8 && x <= PPU_REG_5B+256 && y >= PPU_REG_5A-8 && y <= PPU_REG_5A+232)                
                                       ShowTile_BackGround( addr , x , y , bit_2 , bit_3 , Bitmap );
                x += 8;

                if( x == 256 )  //####
                {                               
                        y+=8;
                        x = 0;  //####
                }
        }

        if( NameTable >= 0x2C00 )
                Table = 0x2000;
        else
                Table = NameTable+0x400;

        NameTable = Table;

        if( PPU_REG_5B > 0 )
        {

        Origin = NameTable;

        ColorTable = NameTable+0x3C0;					//****

        Square = 0;

        Bloc = 1;

        Base = NameTable;

        x = 256;
        y = 0;

        TileCounter = 0;

        for( i = NameTable ; i < NameTable+0x03C0 ; i++ )
        {
                addr = VRAM[ i ]<<4;                                              //****

				if (TileCounter & 0x40)					//****
					index = 4;							//****
				else							  		//****
					index = 0;							//****

				pos = (TileCounter & 0x380) >> 4;		//****
				pos += (TileCounter & 0x1F) >> 2;		//****
				index += (TileCounter & 0x02);			//****
                                color = VRAM[ ColorTable + pos];                 //****
				bit_2 = ReadBit(color, index);			//****
				bit_3 = ReadBit(color, index + 1);		//****
				TileCounter += 1;

                addr += ReadBit( RAM[ 0x2000 ] , 4 )*0x1000;
                                if( x >= PPU_REG_5B-8 && x <= PPU_REG_5B + 256 && y >= PPU_REG_5A-8 && y <= PPU_REG_5A+232)
                                       ShowTile_BackGround( addr , x , y , bit_2 , bit_3 , Bitmap );
                x += 8;

                if( x >= 512 )  //####
                {                               
                        y+=8;
                        x = 256;  //####
                }

        }
        }

        if( NameTable >= 0x2C00 )
                Table = 0x2000;
        else
                Table = NameTable+0x0400;

        NameTable = Table;

        if( PPU_REG_5A > 0 )
        {

        NameTable = Table;

        ColorTable = NameTable+0x3C0;					//****

        CurrentTile = 1;

        Square = 0;

        Bloc = 1;

        Base = NameTable;

        x = 0;
        y = 240;

        TileCounter = 0;

        for( i = NameTable ; i < NameTable+0x03C0 ; i++ )
        {
                addr = VRAM[ i ]<<4;                                              //****

				if (TileCounter & 0x40)					//****
					index = 4;							//****
				else							  		//****
					index = 0;							//****

				pos = (TileCounter & 0x380) >> 4;		//****
				pos += (TileCounter & 0x1F) >> 2;		//****
				index += (TileCounter & 0x02);			//****
                                color = VRAM[ ColorTable + pos];                 //****
				bit_2 = ReadBit(color, index);			//****
                                bit_3 = ReadBit(color, index + 1);              //****
				TileCounter += 1;

                addr += ReadBit( RAM[ 0x2000 ] , 4 )*0x1000;
                                if( x >= PPU_REG_5B-8 && x <= PPU_REG_5B + 256 && y >= PPU_REG_5A-8 && y <= PPU_REG_5A+235)
                                       ShowTile_BackGround( addr , x , y , bit_2 , bit_3 , Bitmap );
                x += 8;

                if( x == 256 )  //####
                {                               
                        y+=8;
                        x = 0; //####
                }

        }
        }

        if( NameTable >= 0x2C00 )
                Table = 0x2000;
        else
                Table = NameTable+0x400;

        NameTable = Table;

        if( PPU_REG_5A > 0 && PPU_REG_5B > 0 )
        {
        ColorTable = NameTable+0x3C0;					//****

        CurrentTile = 1;

        Square = 0;

        Bloc = 1;

        Base = NameTable;

        x = 256;

        y = 240;

        TileCounter = 0;

        for( i = NameTable ; i < NameTable+0x03C0 ; i++ )
        {
                addr = VRAM[ i ]<<4;                                              //****

				if (TileCounter & 0x40)					//****
					index = 4;							//****
				else							  		//****
					index = 0;							//****

				pos = (TileCounter & 0x380) >> 4;		//****
				pos += (TileCounter & 0x1F) >> 2;		//****
				index += (TileCounter & 0x02);			//****
                                color = VRAM[ ColorTable + pos];                 //****
				bit_2 = ReadBit(color, index);			//****
				bit_3 = ReadBit(color, index + 1);		//****
				TileCounter += 1;

                addr += ReadBit( RAM[ 0x2000 ] , 4 )*0x1000;
                                if( x >= PPU_REG_5B-8 && x <= PPU_REG_5B + 256 && y >= PPU_REG_5A-8 && y <= PPU_REG_5A+232)
                                        ShowTile_BackGround( addr , x , y , bit_2 , bit_3 , Bitmap );
                x += 8;

                if( x == 512 )  //####
                {                               
                        y+=8;
                        x = 256 ; //####
                }

        }
        }

                if( ReadBit( RAM[ 0x2001 ] , 4 ) )
                {
                        Refresh_Sprite( NameTable );
                        RAM[ 0x2002 ] |= 0x40;
                }

                        blit( Bitmap , screen , PPU_REG_5B , PPU_REG_5A , X_POS , 0 , 256 , 232 );

                ClearScreen();

}

//
//      InitMachine : Initialize Allegro
//
int     InitMachine()
{
        FILE *Test;

        int x,y;

        // Initialisation d'Allegro
        allegro_init();

        // Mis en place de l'cran
        if( Linear == 1 )
        {
                set_gfx_mode( GFX_VESA2L , 320 , 240 , 0 , 0 );
                goto ok;
        }
        if( Vga == 1 )
        {
                set_gfx_mode( GFX_VGA , 320 , 200 , 0 , 0 );
                goto ok;
        }
        if( ModeX == 1 )
        {
                set_gfx_mode( GFX_MODEX , 320 , 240 , 0 , 0 );
                goto ok;
        }

        set_gfx_mode( GFX_VESA2B , 320 , 240 , 0 , 0 );
        
ok:
        // Cration du bitmap
        Bitmap = create_bitmap( 640 , 600 );
        Bitmap2 = create_bitmap( 640 , 600 );
        Bitmap3 = create_bitmap( 640 , 600 );

        set_pallete( pallete );

        ClearScreen();

        install_keyboard();

        clear_to_color( screen , Black );

        return(1);
}

//
//      TrashMachine : libre tout
//
int     TrashMachine()
{
        // on DESTROYYY (beuarhhh) le bitmap
        destroy_bitmap( Bitmap );

        // on quitte Allegro
        allegro_exit();

        remove_keyboard();

        return(1);
}

int     ShowTile_Sprite( int     addr , int x , int y , int flip , int Bit_0 , int Bit_1 , int Priority , BITMAP *B , int S )
{
        int     x2 = 0 , y2 = 0 , i;
        int     x3 = 0 , y3 = 0;
        int     CurrentColor;
        int     a , b , c;

        int     Size = S;
        int     d;
        
        if( flip == 1 || flip == 3 )
                x3 = x+7;
        else
                x3 = x;

        if( flip == 0 || flip == 1 )
                y3 = y;
        else
                y3 = ( Size == 16 ) ? y+15 : y+7;
        
        for( d = 0 ; d < Size ; d++ )
        {
                if( d >= 0x08 )
                        i = addr+d+0x08;
                else
                        i = addr+d;

                for( x2 = 0 ; x2 < 8 ; x2++ )
                {
                        a = ReadBit( VRAM[ i ] , (7-x2) );
                        b = ReadBit( VRAM[ i+0x0008 ] , (7-x2) );

                        c = ( Bit_1 << 3 ) + ( Bit_0 << 2 ) + ( b << 1 ) + a;

                        if( Priority == 1 && Screen_Info[ x3 ][ y3 ] == 1 )
                                goto next_pixel;

                        if( (c == 0x04 ) || ( c == 0x08 ) || ( c == 0x0C ) )
                        {
                                CurrentColor = VRAM[ 0x3F10 ];
                                c = 0;
                        }
                        else
                                CurrentColor = VRAM[ 0x3F10+c ];

                        if( ( 0x3F10+c ) != 0x3F10 )      //****
                               _putpixel( B , x3 , y3 , CurrentColor );
next_pixel:
                        if( flip == 1 || flip == 3 )
                                x3--;
                        else
                                x3++;
                }
                if( flip == 2 || flip == 3 )
                        y3--;
                else
                        y3++;

                if( flip == 1 || flip == 3 )
                        x3 = x+7;
                else
                        x3 = x;
        }

        return(1);
}

int     Refresh_Sprite( void )
{
        int     x,y;
        int     tile,addr,i;
        int     flip;
        int     NameTable;
        int     Size;


        Size = 0x08 << ReadBit( RAM[ 0x2000 ] , 5 );

        switch( RAM[ 0x2000 ] & 0x03 )
        {
                case    0:
                        NameTable = 0x2000;
                        break;
                case    1:
                        NameTable = 0x2400;
                        break;
                case    2:
                        NameTable = 0x2800;
                        break;
                case    3:
                        NameTable = 0x2C00;
                        break;
        }

        for( i = 0x00FC ; i >= 0x0000 ; i -= 0x0004 )        
        {
                y = SRAM[ i ]+1+PPU_REG_5A;
                x = SRAM[ i+0x0003 ]+PPU_REG_5B;

                tile = SRAM[ i+0x0001 ];

                if( SRAM[ i ] > 232 )
                        continue;

                if( ReadBit( RAM[ 0x2000 ] , 5 ) != 1 )
                {
                        if( ReadBit( RAM[ 0x2000 ] , 3 ) == 0 )
                                addr = (tile<<4);
                        else
                                addr = (tile<<4)+0x1000;
                }
                else
                {
                        // Sprite size is 8x16

                        if( ReadBit( tile , 0 ) == 1 )
                        {
                                tile--;
                                addr = ( tile << 4 )+ 0x1000;
                        }
                        else
                        {
                                if( ReadBit( RAM[ 0x2000 ] , 3 ) == 0 )
                                        addr = (tile << 4);
                                else            
                                        addr = (tile << 4 )+0x1000;
                        }
                }                                


                flip = ( SRAM[ i + 0x0002 ] & 0xC0 ) >> 6;

                        ShowTile_Sprite( addr , x , y , flip , ReadBit( SRAM[ i+0x0002 ] , 0 ) , ReadBit( SRAM[ i+0x0002 ] , 1 ) , ReadBit( SRAM[ i+0x0002 ] , 5 ) , Bitmap ,Size);                     
        }
}

//
// ClearScreen()
//

int ClearScreen()
{
        int Color;

        //
        // Efface l'cran dans Bitmap avec la couleur adequate
        //

        Color = RAM[ 0x2001 ]&0xE0;

        switch( Color )
        {
                case 0:
                        clear_to_color( Bitmap , Black );
                        break;
                case 32:
                        clear_to_color( Bitmap , Red );
                        break;
                case 64:
                        clear_to_color( Bitmap , Green );
                        break;
                case 128:
                        clear_to_color( Bitmap , Blue );
                        break;
                default:
                        TrashMachine();
                        printf("xNes error ! Please report me ( shingouky@geocities.com ) this message :\n");
                        puts("\tERROR IN CLEARSCREEN().");
                        exit(1);
                        clear( Bitmap );
        }                        
}
        
int     Swap_To_Gui()
{
        int     key;

        clear_to_color( screen , 0 );
        textout_centre( screen , font , "X-Nes primitive GUI" , SCREEN_W/2 , 10 , Black );
        textout( screen , font , "Press ESC to quit the \"GUI\"" , 0 , 50 , Black );
        textout( screen , font , "1. Reset the virtual nes" , 20 , 70 , Black );
        textout( screen , font , "2. Load an another cartridge" , 20 , 80 , Black );
        textout( screen , font , "3. Snapshot the screen" , 20 , 90 , Black );
        textout( screen , font , "4. Quit XNes" , 20 , 100 , Black );

        remove_keyboard(); // J'enlve le clavier

        for( ;; )
        {
                if( kbhit() )
                {
                        key = getch();
                        switch( key )
                        {
                                case '1':
                                        Reset_Nes();
                                        break;
                                case '3':
                                        SnapScreen();
                                        break;
                                case '4':
                                        Quit();
                                        break;
                                case 27:
                                        install_keyboard();
                                        clear_to_color( screen , Black );
                                        return(1);
                                        break;
                        }
                }
        }                
}

ShowTile_BackGround( int addr , int x , int y , int Bit_0 , int Bit_1 ,BITMAP *B )
{
#ifdef DJGPP
    void *bitmap, *vram, *info_scr, *color_table;
    int   bm_offset, info_offset;

    bm_offset   = B->w;
    bitmap      = B->line[0] + x + (y * bm_offset);
    color_table = &VRAM[0x3F00 + (Bit_1 << 3) + (Bit_0 << 2)];
    vram        = &VRAM[addr];
    info_scr    = &Screen_Info[x][y];
    info_offset = 640;

    asm (
        "movl  %0,%%esi;"       // VRAM pointer in esi
        "movl  %1,%%edi;"       // destination bitmap pointer in edi
        "movl  %2,%%ebx;"       // priority array pointer in ebx

        "movb  $8,%%ch;"        // vertical loop

    "1:  movb  (%%esi),%%dl;"   // get plane 0
        "movb  8(%%esi),%%dh;"  // get plane 1
        "incl  %%esi;"          // incremente VRAM pointer

        "movb  $8,%%cl;"        // horizontal loop

    "2:  xorl  %%eax,%%eax;"
        "shlb  $1,%%dh;"        // bit 1
        "rclb  $1,%%al;"
        "shlb  $1,%%dl;"        // bit 0
        "rclb  $1,%%al;"

        "testb $0x03,%%al;"     // priority
        "setnz (%%ebx);"        // (warning: 486 cpu only)
        "incl  %%ebx;"

        "addl  %5,%%eax;"       // get color
        "movb  (%%eax),%%al;"
        "movb  %%al,(%%edi);"   // very very fast putpixel
        "incl  %%edi;"

        "decb  %%cl;"           // next pixel
        "jnz   2b;"

        "addl  %3,%%edi;"       // incremente bitmap pointer
        "subl  $8,%%edi;"
        "addl  %4,%%ebx;"       // incremente priority array pointer
        "subl  $8,%%ebx;"

        "decb  %%ch;"           // next line
        "jnz   1b;"
        : 
        : "m" (vram), "m" (bitmap), "m" (info_scr),
          "m" (bm_offset), "m" (info_offset),
          "m" (color_table)
        : "ax", "bx", "cx", "dx", "si", "di", "cc"
    );

#else
    int i;
    int x3, y3;
    int x2;
    int current_color;
    int high_color;
    int a , b , c;

    x3 = x;
    y3 = y;
    high_color = ( Bit_1 << 3 ) + ( Bit_0 << 2 );

    for( i = addr ; i <= addr+0x7 ; i++ )
    {                        
        for( x2 = 7 ; x2 >= 0 ; x2-- )
        {
            a = ReadBit( VRAM[ i ] , x2 );
            b = ReadBit( VRAM[ i+0x0008 ] , x2 );
            c = high_color + ( b << 1 ) + a;

            Screen_Info[ x3 ] [ y3 ] = ( c & 0x03 ) ? 1 : 0;

            current_color = VRAM[ 0x3F00+c ];

            _putpixel( B , x3 , y3 , current_color );

            x3++;
        }
        y3++;
        x3 = x;
    }

#endif

    return(1);
}

